Mail::Box::Locker::NFS(3)

NAME
Mail::Box::Locker::NFS - lock a folder with a separate file, NFS-safe

INHERITANCE
 Mail::Box::Locker::NFS
   is a Mail::Box::Locker
   is a Mail::Reporter

SYNOPSIS
 See Mail::Box::Locker

DESCRIPTION
Like the "::DotLock" locker, but then in an NFS-safe fashion. Over NFS, the creation of a file is not atomic. The "::DotLock" locker depends on an atomic "open" system call, hence in not usable to lock a folder which accessed over NFS. The "::NFS" locker is therefore more complicated (so therefore slower), but will work for NFS --and for local disks as well.

Extends "DESCRIPTION" in Mail::Box::Locker.

METHODS
Extends "METHODS" in Mail::Box::Locker.

  Constructors
Extends "Constructors" in Mail::Box::Locker.

Mail::Box::Locker::NFS->new(%options)
     -Option --Defined in       --Default
      expires  Mail::Box::Locker  1 hour
      file     Mail::Box::Locker  undef
      folder   Mail::Box::Locker  <undef>
      log      Mail::Reporter     'WARNINGS'
      method   Mail::Box::Locker  'NFS'
      timeout  Mail::Box::Locker  10
      trace    Mail::Reporter     'WARNINGS'

    expires => SECONDS
    file => FILENAME
    folder => FOLDER
    log => LEVEL
    method => STRING|CLASS|ARRAY
    timeout => SECONDS|'NOTIMEOUT'
    trace => LEVEL

  Attributes
Extends "Attributes" in Mail::Box::Locker.

$obj->expires( [SECONDS] )
    Inherited, see "Attributes" in Mail::Box::Locker

$obj->timeout( [SECONDS] )
    Inherited, see "Attributes" in Mail::Box::Locker

  The Locker
Extends "The Locker" in Mail::Box::Locker.

$obj->filename( [$filename] )
    Inherited, see "The Locker" in Mail::Box::Locker

$obj->folder( [$folder] )
    Inherited, see "The Locker" in Mail::Box::Locker

$obj->name()
    Inherited, see "The Locker" in Mail::Box::Locker

  Locking
Extends "Locking" in Mail::Box::Locker.

$obj->hasLock()
    Inherited, see "Locking" in Mail::Box::Locker

$obj->isLocked()
    Inherited, see "Locking" in Mail::Box::Locker

$obj->lock()
$obj->unlock()
    Inherited, see "Locking" in Mail::Box::Locker

  Error handling
Extends "Error handling" in Mail::Box::Locker.

$obj->AUTOLOAD()
    Inherited, see "Error handling" in Mail::Reporter

$obj->addReport($object)
    Inherited, see "Error handling" in Mail::Reporter

$obj->defaultTrace( [$level]|[$loglevel, $tracelevel]|[$level, $callback] )
Mail::Box::Locker::NFS->defaultTrace( [$level]|[$loglevel, $tracelevel]|[$level, $callback] )
    Inherited, see "Error handling" in Mail::Reporter

$obj->errors()
    Inherited, see "Error handling" in Mail::Reporter

$obj->log( [$level, [$strings]] )
Mail::Box::Locker::NFS->log( [$level, [$strings]] )
    Inherited, see "Error handling" in Mail::Reporter

$obj->logPriority($level)
Mail::Box::Locker::NFS->logPriority($level)
    Inherited, see "Error handling" in Mail::Reporter

$obj->logSettings()
    Inherited, see "Error handling" in Mail::Reporter

$obj->notImplemented()
    Inherited, see "Error handling" in Mail::Reporter

$obj->report( [$level] )
    Inherited, see "Error handling" in Mail::Reporter

$obj->reportAll( [$level] )
    Inherited, see "Error handling" in Mail::Reporter

$obj->trace( [$level] )
    Inherited, see "Error handling" in Mail::Reporter

$obj->warnings()
    Inherited, see "Error handling" in Mail::Reporter

  Cleanup
Extends "Cleanup" in Mail::Box::Locker.

$obj->DESTROY()
    Inherited, see "Cleanup" in Mail::Box::Locker

DIAGNOSTICS

Warning: Folder $folder already locked over nfs
    Do not try to lock the folder when the application already has the lock: it will give you dead-locks.

Error: Package $package does not implement $method.
    Fatal error: the specific package (or one of its superclasses) does not implement this method where it should. This message means that some other related classes do implement this method however the class at hand does not. Probably you should investigate this and probably inform the author of the package.

Warning: Removed expired lockfile $filename.
    A lock file was found which was older than the expiration period as specified with new(timeout). The lock file was successfully removed.

Error: Unable to remove expired lockfile $lockfile: $!
    A lock file was found which was older than the expiration period as specified with the new(timeout) option. It is impossible to remove that lock file, so we need to wait until it vanishes by some external cause.

SEE ALSO
This module is part of Mail-Box distribution version 3.008, built on October 04, 2019. Website: http://perl.overmeer.net/CPAN/

LICENSE
Copyrights 2001-2019 by [Mark Overmeer]. For other contributors see ChangeLog.

This program is free software; you can redistribute it and/or modify it under the same terms as Perl itself. See http://dev.perl.org/licenses/